#include <bits/stdc++.h>

#define int long long
#define double long double
using namespace std;

void solve() {
    int w, h;
    cin >> w >> h;
    vector<vector<int>> a(w, vector<int>(h));
    for (int i = 0; i < w; ++i) {
        for (int j = 0; j < h; ++j) {
            cin >> a[i][j];
        }
    }
    int s;
    cin >> s;
    for (int i = 0; i < 1 << w; ++i) {
        for (int j = 0; j < 1 << h; ++j) {
            int sum = 0;
            for (int k = 0; k < w; ++k) {
                if ((i >> k) & 1) {
                    continue;
                }
                for (int l = 0; l < h; ++l) {
                    if ((j >> l) & 1) {
                        continue;
                    }
                    sum += a[k][l];
                }
            }
            if (sum != s) {
                continue;
            }
            vector<pair<int, int>> ans;
            if (sum == s) {
                for (int k = w - 1; k >= 0; --k) {
                    if ((i >> k) & 1) {
                        ans.emplace_back(2, k + 1);
                    }
                }
                for (int k = h - 1; k >= 0; --k) {
                    if ((j >> k) & 1) {
                        ans.emplace_back(1, k + 1);
                    }
                }
            }
            cout << "YES\n" << ans.size() << "\n";
            for (auto item: ans) {
                cout << item.first << " " << item.second << "\n";
            }
            return;
        }
    }
    cout << "NO\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}