#include <bits/stdc++.h>

#define int long long
using namespace std;

vector<vector<int>> g;
vector<vector<int>> dist;

void dfs(int v, int p, int s, int d) {
    dist[s][v] = d;
    for (auto u: g[v]) {
        if (u != p) {
            dfs(u, v, s, d + 1);
        }
    }
}

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    g.resize(n);
    dist.resize(n, vector<int>(n));
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    if (t == 0) {
        int l = 1, r = n - 1;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            int c = n - 1 - 2 * (mid + 1);
            if (c <= 0) {
                r = mid;
                continue;
            }
            int res = (c + 2 * k) / (2 * k + 1);
            if (res > k) {
                r = mid;
            } else {
                l = mid;
            }
        }
        cout << l << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}