#include <bits/stdc++.h>

#define int long long
#define double long double
using namespace std;

vector<int> l, r, val;
vector<int> order;

void dfs(int v) {
    if (val[v] == -1) {
        order.push_back(v);
    }
    if (l[v] != 0) {
        dfs(l[v]);
    }
    if (val[v] == 0) {
        order.push_back(v);
    }
    if (r[v] != 0) {
        dfs(r[v]);
    }
    if (val[v] == 1) {
        order.push_back(v);
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n >> q;
    l.resize(n + 1);
    r.resize(n + 1);
    val.resize(n + 1, -1);
    set<int> s;
    for (int i = 1; i <= n; ++i) {
        s.insert(i);
    }
    for (int i = 1; i <= n; ++i) {
        cin >> l[i] >> r[i];
        s.erase(l[i]);
        s.erase(r[i]);
    }
    for (int i = 0; i < q; ++i) {
        int t;
        cin >> t;
        if (t == 1) {
            int l1, r1, x;
            cin >> l1 >> r1 >> x;
            for (int j = l1; j <= r1; ++j) {
                val[j] = x;
            }
        } else {
            int x;
            cin >> x;
            order.clear();
            dfs(*s.begin());
            for (int j = 0; j < order.size(); ++j) {
                if (order[j] == x) {
                    cout << j + 1 << "\n";
                    break;
                }
            }
        }
    }
    return 0;
}