#include "vector"
#include "iostream"
#include "unordered_map"

using namespace std;

void solve() {
    int h, w;
    cin >> h >> w;
    int a[h][w];
    for (int i = 0; i < h; ++i) {
        for (int j = 0; j < w; ++j) {
            cin >> a[i][j];
        }
    }
    int s;
    cin >> s;
    for (int i = 0; i < 1 << h; ++i) {
        int wl = w / 2, wr = w - wl;
        vector<int> mp(1400, -1);
        for (int j = 0; j < 1 << wl; ++j) {
            int sum = 0;
            for (int k = 0; k < h; ++k) {
                if ((i >> k) & 1) {
                    continue;
                }
                for (int l = 0; l < wl; ++l) {
                    if ((j >> l) & 1) {
                        continue;
                    }
                    sum += a[k][l];
                }
            }
            mp[sum] = j;
        }
        for (int j = 0; j < 1 << wr; ++j) {
            int sum = 0;
            for (int k = 0; k < h; ++k) {
                if ((i >> k) & 1) {
                    continue;
                }
                for (int l = 0; l < wr; ++l) {
                    if ((j >> l) & 1) {
                        continue;
                    }
                    sum += a[k][l + wl];
                }
            }
            if (mp[s - sum] != -1) {
                int j1 = mp[s - sum];
                int cnt = 0;
                string ans;
                for (int k = h - 1; k >= 0; --k) {
                    if ((i >> k) & 1) {
                        ans += "1 " + to_string(k + 1) + "\n";
                        ++cnt;
                    }
                }
                for (int k = wl - 1; k >= 0; --k) {
                    if ((j1 >> k) & 1) {
                        ans += "2 " + to_string(k + 1) + "\n";
                        ++cnt;
                    }
                }
                for (int k = wr - 1; k >= 0; --k) {
                    if ((j >> k) & 1) {
                        ans += "2 " + to_string(wl + k + 1) + "\n";
                        ++cnt;
                    }
                }
                cout << "YES\n" << cnt << "\n" << ans;
                return;
            }
        }
    }
    cout << "NO\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}