#include <bits/stdc++.h>

#define int long long
using namespace std;

vector<vector<int>> g;
vector<vector<int>> dist;

void dfs(int v, int p, int s, int d) {
    dist[s][v] = d;
    for (auto u: g[v]) {
        if (u != p) {
            dfs(u, v, s, d + 1);
        }
    }
}

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    g.resize(n);
    dist.resize(n, vector<int>(n));
    for (int i = 0; i < n - 1; ++i) {
        int u, v;
        cin >> u >> v;
        --u, --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    for (int i = 0; i < n; ++i) {
        dfs(i, i, i, 0);
    }
    if (t == 0 && k == 1) {
        int ans = n - 1;
        for (int i = 0; i < n; ++i) {
            int res = 1;
            for (int j = 0; j < n; ++j) {
                res = max(res, min(dist[0][j], 1 + dist[i][j]));
            }
            ans = min(ans, res);
        }
        cout << ans << "\n";
    } else {
        exit(1);
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    solve();
    return 0;
}